from typing import Final, List

from PIL import Image

from edge.image.helpers import ImHelpers
from edge.types.blob import MemBlob
from edge.types.image import ImRgba
from edge.image.types.builder import PlateImConf
from edge.types.shape.rect import RectF


class PlateImProfile:
    def __init__(self, conf: PlateImConf):
        self._w: Final[int] = conf.width
        self._h: Final[int] = conf.height

    def process(self, scene_dh_data: ImRgba, plate_bbox: RectF) -> List[MemBlob]:
        blob_data = ImHelpers.mk_crop_resize_jpeg(
            scene_dh_data, plate_bbox, self._w, self._h, Image.Resampling.BICUBIC)

        return [MemBlob('plate', scene_dh_data.ts, blob_data)]
