from abc import ABCMeta, abstractmethod

from edge.services.tl.tl_signal import Signal
from edge.services.types.tl import TlState, TlHaltSpanInfo, TlRoute


class ITrafficLight(metaclass=ABCMeta):
    @abstractmethod
    def get_state(self, ts: int) -> TlState:
        pass

    @abstractmethod
    def get_signal_h(self, min_ts: int, max_ts: int, route: TlRoute | None = None) -> Signal:
        pass

    @abstractmethod
    def get_halt_span_info(self, halt_span_ts: int, route: TlRoute | None = None) -> TlHaltSpanInfo:
        pass
