import os

from edge import eventlog
from edge.types.exceptions import JnodeError
from edge.services.types.stats import StatsServiceConf


def decode__stats_service_conf(unit_type: str, unit_name: str, monitoring_jnode: dict) -> StatsServiceConf:
    """
    :raise JnodeError:
    """
    filepath = monitoring_jnode.get('path')
    if not (type(filepath) in [str] and len(filepath) < 64 and os.path.isabs(filepath)):
        eventlog.log_e_param('#/path')
        raise JnodeError

    interval_sec = monitoring_jnode.get('tout')
    if not (int == type(interval_sec) and 0 <= interval_sec <= 255):
        eventlog.log_e_param('#/tout')
        raise JnodeError

    return StatsServiceConf(unit_type, unit_name, filepath, interval_sec)
