from edge.services.types.systest import SystestServiceConf
from edge.support import fs
from edge.webserver.sysconf.uiconf.controller import CtrlUiconf


def decode__systest_service_conf(conf_path: str | None = None) -> SystestServiceConf:
    """
    :param conf_path:
        /etc/edge/setupstore/admin/actions/systest/0
    :raise JnodeError:
    """
    session_active = CtrlUiconf.get_systest()

    if conf_path:
        jnode = fs.load_json3(conf_path, default=dict())
        rw_jnode = jnode.get('rw') or dict()
        cert_jnode = rw_jnode.get('certificate')
    else:
        cert_jnode = None

    return SystestServiceConf(session_active, cert_jnode)
