from abc import abstractmethod
from typing import Final

from edge.services.types.service import IService


class PlateInfoServiceConf:
    def __init__(self, info_path: str | None) -> None:
        self.info_path: Final[str | None] = info_path


class IPlateInfoService(IService):
    @abstractmethod
    def get_country_code(self, template_ref: int) -> int:
        pass

    @abstractmethod
    def get_plate_attrs(self, template_ref: int) -> str | None:
        pass

    @abstractmethod
    def get_plate_template(self, template_ref: int) -> str | None:
        pass
