from abc import ABCMeta, abstractmethod
from typing import Callable, Final

from edge.services.types.service import IService


class StatsServiceConf:
    def __init__(self, unit_type: str, unit_name: str, filepath: str, interval_sec: int) -> None:
        self.type: Final[str] = unit_type
        self.name: Final[str] = unit_name

        self.filepath: Final[str] = filepath
        self.filepath_tmp: Final[str] = filepath + '.tmp'
        self.interval_sec: Final[int] = interval_sec


class IStatsProvider(metaclass=ABCMeta):
    def collect_stats(self, json_handler: Callable[[dict], None]) -> None:
        pass


class IStatsService(IService):
    @abstractmethod
    def add_providers(self, providers: list[IStatsProvider]) -> None:
        pass
