from abc import abstractmethod
from typing import Final

from edge.services.types.service import IService


class SystestServiceConf:
    def __init__(self, session_active: bool, cert_jnode: dict | None = None) -> None:
        self.session_active: Final[bool] = session_active
        self.cert_jnode: Final[dict | None] = cert_jnode


class ISystestService(IService):
    @property
    @abstractmethod
    def session_active(self) -> bool:
        pass

    @abstractmethod
    def serialize(self, jnode: dict) -> dict:
        pass
