from edge.types.timespan import decode__timespan
from edge.types.trend import ImPlace, LrTrendItem, LrTrend


def encode__im_place(self: ImPlace) -> tuple[int, int, int]:
    return self._r, self._min_x + self._r, self._min_y + self._r


def decode__im_place(jnode: list[int]) -> ImPlace:
    if len(jnode) != 3:
        raise ValueError

    return ImPlace(*jnode)


def encode__lr_trend_item(self: LrTrendItem) -> dict:
    jnode = {
        'place': encode__im_place(self.place),
        'range': [self.range.min_ts, self.range.max_ts]
    }

    if self.event:
        jnode['event'] = True

    return jnode


def decode__lr_trend_item(jnode: dict) -> LrTrendItem:
    place = decode__im_place(jnode['place'])
    span = decode__timespan(jnode['range'])
    return LrTrendItem(place, span, bool(jnode.get('event')))


def encode__lr_trend(self: LrTrend) -> dict:
    return {
        'plate-wh': [self.max_vrp_bbox_w, self.max_vrp_bbox_h],
        'timeline': [encode__lr_trend_item(item) for item in self.items]
    }


def decode__lr_trend(lost_tout_usec: int, dead_tout_usec: int, jnode: dict) -> LrTrend:
    max_plate_wh = jnode['plate-wh']
    items: list[LrTrendItem] = [decode__lr_trend_item(x) for x in jnode['timeline']]
    return LrTrend(lost_tout_usec, dead_tout_usec, max_plate_wh, items)
