from edge.webserver.sysconf.uimod import rootinfo
from edge.webserver.sysconf.uimod import unet


class RootApi:
    @staticmethod
    def get_units_info(urefs: list[str] = None) -> list[unet.UnitInfo]:
        root_uinfo = rootinfo.decode_info().root
        if not urefs:
            return [root_uinfo]

        unit_infos = list[unet.UnitInfo]()
        for uref in urefs:
            unit_uinfo = unet.find_unit_r(root_uinfo, uref=uref)
            if unit_uinfo:
                unit_infos.append(unit_uinfo)

        return unit_infos
