from edge.types.identity import Identity


def create_unit__ipcom___waga(unit_name: str, waga_conf: dict) -> tuple[str, dict]:
    waga_pub_conf = waga_conf.get('rw', {}).get('conf')
    waga_ev_matcher = waga_pub_conf['event-matcher']
    waga_server = waga_pub_conf['server']

    uiref = Identity(unit_name)
    parent_uiref = uiref.parent

    return unit_name, {
        'bundle': ['libunity_ipcom', '1.0.0'],
        'type': parent_uiref.type,
        'name': parent_uiref.ref,
        'units':
        [
            {
                'type': uiref.type,
                'name': uiref.ref,
                'conf': {
                    'endpoint': f'{waga_server["host"]}:{waga_server["port"]}',
                    'lanes': waga_ev_matcher['lanes'],
                    'match-dist': waga_ev_matcher['max-vrp-dist'],
                    'tout-ms': waga_ev_matcher['match-tout'],
                    'vendor': waga_conf.get('ro', {}).get('vendor', '')
                }
            }
        ]
    }
