from edge.support import fs


class MainConfBuilder:
    def __init__(self) -> None:
        self._jnode = dict()

    def setup_blobstore(self, bs_ident: str, chan_ident: str) -> None:
        self._jnode.update({
            'Store': [bs_ident, chan_ident]
        })

    def setup_react(self, spool_dir: str, react_dir: str) -> None:
        self._jnode.update({
            'React': fs.join_path(spool_dir, react_dir)
        })

    def setup_codec(self, quality: int) -> None:
        self._jnode.update({
            'codec': {
                'Scale': {
                    'MaxWidth': 65535,
                    'MaxHeight': 65535
                },
                'Encode': {
                    'Format': 'H264',
                    'Quality': quality,
                    'PreferGpu': True
                }
            }
        })

    def build(self) -> dict:
        return self._jnode
