from edge.webserver.sysconf.types.conf import IUiConfProvider


class HaltConfBuilder:
    def __init__(self, uimod_psuctl: IUiConfProvider | None) -> None:
        psuctl_ref = uimod_psuctl.ref if uimod_psuctl else None

        if psuctl_ref is not None:
            self._lines: list[str] = [
                f'0:/opt/edge/bin/psuctl run-uref {psuctl_ref} led-camera color G blink 0HZ;',

                f'1:/opt/edge/bin/psuctl run-uref {psuctl_ref} led-camera color R blink 1HZ;'
                f'/opt/edge/bin/psuctl run-uref {psuctl_ref} camera-reboot',

                f'2:/opt/edge/bin/psuctl run-uref {psuctl_ref} led-camera color R blink 0HZ;'
                f'/opt/edge/bin/psuctl run-uref {psuctl_ref} camera-reboot'
            ]
        else:
            self._lines: list[str] = []

    def setup_lines(self, lines: list[str]) -> None:
        self._lines = lines

    def build(self) -> str:
        return '\n'.join(self._lines)
