from typing import Final

from edge.webserver.sysconf.dgmod.mg.dgconf.mgd_halt import HaltConfBuilder
from edge.webserver.sysconf.dgmod.mg.dgconf.mgd_unit import UnitConfBuilder
from edge.webserver.sysconf.dgmod.mg.uiconf import IUiConfProvider2


class FusionUiConfProvider(IUiConfProvider2):
    def __init__(self, uimod_id: str) -> None:
        self._uimod_id: Final[str] = uimod_id

    def setup_builders(self,
                       unit_builder: UnitConfBuilder,
                       halt_builder: HaltConfBuilder) -> None:

        unit_builder.setup_vst_bus([
            f'mg{unit_builder.uimod_id}-tr{self._uimod_id}-scene'
        ], require_mono8=True)
