from typing import Final

from edge.webserver.sysconf.dgmod.mg.dgconf.mgd_halt import HaltConfBuilder
from edge.webserver.sysconf.dgmod.mg.dgconf.mgd_unit import UnitConfBuilder
from edge.webserver.sysconf.dgmod.mg.uiconf import IUiConfProvider2


class _UiConfProvider(IUiConfProvider2):
    def __init__(self, uimod_id: str, uiconf: dict) -> None:
        self._uimod_id: Final[str] = uimod_id
        self._uiconf: Final[dict] = uiconf

    def setup_builders(self,
                       unit_builder: UnitConfBuilder,
                       halt_builder: HaltConfBuilder) -> None:

        pri_jnode: dict = self._uiconf['ro']
        with_trafficlight_65535 = pri_jnode.get('with-trafficlight.65535', False)

        if with_trafficlight_65535:
            return

        vendor: str = pri_jnode.get('vendor') or 'zonechecker'
        if vendor == 'zonechecker':
            unit_builder.setup_vst_bus([
                f'mg{unit_builder.uimod_id}-zc{self._uimod_id}-scene'
            ])


RedlightUiConfProvider = _UiConfProvider
RailroadUiConfProvider = _UiConfProvider
