from typing import Final

from edge.webserver.sysconf.dgmod.ra.ra_api import ApiConfBuilder
from edge.webserver.sysconf.dgmod.ra.ra_halt import HaltConfBuilder
from edge.webserver.sysconf.dgmod.ra.ra_main import MainConfBuilder
from edge.webserver.sysconf.dgmod.ra.uiconf import IUiConfProvider2


class FusionUiConfProvider(IUiConfProvider2):
    def __init__(self, uimod_id: str) -> None:
        self._uimod_id: Final[str] = uimod_id

    def setup_builders(self,
                       api_builder: ApiConfBuilder | None,
                       main_builder: MainConfBuilder,
                       halt_builder: HaltConfBuilder) -> None:

        main_builder.setup_scene_event_args([
            f'ra{main_builder.uimod_id}-tr{self._uimod_id}-scene'
        ])
