from typing import Final

from edge.webserver.sysconf.dgmod.rg.rg_halt import HaltConfBuilder
from edge.webserver.sysconf.dgmod.rg.rg_main import MainConfBuilder
from edge.webserver.sysconf.dgmod.rg.uiconf import IUiConfProvider2


class LprUiConfProvider(IUiConfProvider2):
    def __init__(self, uimod_id: str) -> None:
        self._uimod_id: Final[str] = uimod_id

    def setup_builders(self,
                       main_builder: MainConfBuilder,
                       halt_builder: HaltConfBuilder) -> None:

        main_builder.setup_dec_streamer__bus_args([
            f'rg{main_builder.uimod_id}-lr{self._uimod_id}-scene',
        ])
