from typing import Final

from edge.webserver.sysconf.dgmod.rn.rn_main import MainConfBuilder
from edge.webserver.sysconf.dgmod.rn.rn_setupstore import SetupStoreConfBuilder
from edge.webserver.sysconf.dgmod.rn.uiconf import IUiConfProvider2


class WebServerUiConfProvider(IUiConfProvider2):
    def __init__(self, uimod_id: str) -> None:
        self._uimod_id: Final[str] = uimod_id

    def setup_builders(self, main_builder: MainConfBuilder, ss_builder: SetupStoreConfBuilder) -> None:
        main_builder.setup_event_blobs('or{0}-or{0}-store'.format(main_builder.uimod_id), 'JPEG')
        main_builder.setup_event_args([
            f'or{main_builder.uimod_id}-ws{self._uimod_id}-scene'
        ])
