from typing import Final

from edge.webserver.sysconf.dgmod.rs.rs_main import MainConfBuilder
from edge.webserver.sysconf.dgmod.rs.rs_setupstore import SetupStoreConfBuilder
from edge.webserver.sysconf.dgmod.rs.uiconf import IUiConfProvider2


class MvCameragUiConfProvider(IUiConfProvider2):
    def __init__(self, uimod_id: str, uiconf: dict) -> None:
        self._uimod_id: Final[str] = uimod_id
        self._uiconf: Final[dict] = uiconf

    def setup_builders(self, main_builder: MainConfBuilder, ss_builder: SetupStoreConfBuilder) -> None:
        pri_jnode: dict = self._uiconf['rw']
        vs_jnode: dict = pri_jnode['videostream']

        main_builder.setup_stream__cam_fps(vs_jnode['fps'])
