from edge import eventlog
from edge.webserver.sysconf.uiconf.types.intrinsics import Intrinsics, Intrinsics2


def decode__intrinsic_sensorwpx_sensorhpx_focalpx(
        intrinsic_jnode: Intrinsics | Intrinsics2 | None) -> tuple[float, float, float]:

    if intrinsic_jnode is None:
        eventlog.log_e('fail: NotImplementedError')
        raise NotImplementedError

    elif intrinsic_jnode.get('calibration'):
        jnode: Intrinsics = intrinsic_jnode
        sensor_w_px, sensor_h_px = jnode['frustum']['sensor-size']
        focal_dist_px = jnode['calibration']['focal-dist']

    else:
        jnode: Intrinsics2 = intrinsic_jnode
        sensor_w_px, sensor_h_px = jnode['frustum']['sensor-size']

        focus_dist_mm: float = jnode['frustum']['focal-dist']
        pixel_size_um: float = jnode['frustum']['pixel-size']
        focal_dist_px = focus_dist_mm / pixel_size_um * 1000.0

    return sensor_w_px, sensor_h_px, focal_dist_px
