from typing import Final


class DetUlimits:
    def __init__(self, max_image_w: int) -> None:
        self._max_image_w: Final[int] = max_image_w

    def get_image_profiles(self, with_vehicle_image: bool, with_scene_image: bool) -> dict:
        if not with_vehicle_image and not with_scene_image:
            return dict()

        limits_jnode = {
            'images': dict()
        }

        if with_vehicle_image:
            limits_jnode['images']['vehicle'] = {
                'max-width': 640
            }

        if with_scene_image:
            limits_jnode['images']['scene'] = {
                'max-width': self._max_image_w
            }

        return limits_jnode


def get_terminal_detector_image_limits(
        max_image_w: int,
        with_vehicle_image: bool,
        with_scene_image: bool,
        ) -> dict:

    return DetUlimits(max_image_w).get_image_profiles(with_vehicle_image, with_scene_image)
