from typing import Final, TypedDict

from edge.webserver.sysconf.uimod import unet
from edge.webserver.sysconf.uimod.unet import UnitInfo
from edge.webserver.sysconf.uimod.utype import UTYPE_EVENTSTORE


class EsStoreInfo(TypedDict):
    id: str
    ref: str
    name: str


class EsUlimits:
    def __init__(self, root_uinfo: UnitInfo) -> None:
        self._root_uinfo: Final[UnitInfo] = root_uinfo

    @property
    def store_infos(self) -> list[EsStoreInfo]:
        def handler(uinfo: unet.UnitInfo) -> dict:
            return {
                'id': uinfo['ref'].split('.')[-1],  # TODO: for current ui
                'ref': uinfo['ref'],
                'name': uinfo.get('name')
            }

        return unet.map_units_r(self._root_uinfo, handler, utypes=[UTYPE_EVENTSTORE])
