from typing import Dict, List

from edge.services.types.lane import LaneServiceConf, LaneConf


def decode__lane_service_conf(jnode: Dict) -> LaneServiceConf:
    """
    :param jnode:
        main.conf#/road-mask
    """
    lanes_jnode: List[Dict] = jnode.get('lanes', [])
    lane_to_mask_list: List[LaneConf] = [(x['name'], x['mask']) for x in lanes_jnode]
    mask_w, mask_h = jnode.get('scene-wh', [0, 0])

    return LaneServiceConf(lane_to_mask_list, mask_w, mask_h)
