from typing import Final, List

from edge.types.jnode.imageref import ImageRef

from renderer.types.face import FaceSceneItem
from renderer.types.lr import LrSceneItem
from renderer.types.ra import RaSceneItem


class TrSceneItem:
    def __init__(self, lr_item: LrSceneItem, ra_item: RaSceneItem) -> None:
        self.lr_item: Final[LrSceneItem] = lr_item
        self.ra_item: Final[RaSceneItem] = ra_item


class TrScene:
    def __init__(self,
                 im_ref: ImageRef,
                 tr_items: List[TrSceneItem],
                 lr_items: List[LrSceneItem],
                 ra_items: List[RaSceneItem],
                 face_items: List[FaceSceneItem]) -> None:

        self.im_ref: Final[ImageRef] = im_ref

        self.tr_items: Final[List[TrSceneItem]] = tr_items
        self.lr_items: Final[List[LrSceneItem]] = lr_items
        self.ra_items: Final[List[RaSceneItem]] = ra_items

        self.face_items: Final[List[FaceSceneItem]] = face_items
