from edge.image.types.builder import EventMeasImBuilderConf
from edge.types.identity import Identity
from edge.support.mask import MaskConf
from edge.support.schedule import ScheduleConf

from speedcontrol.events.ticket import TicketInfo


class RuleLimits:
    def __init__(self, max_standing_time: int):
        self.max_standing_time = max_standing_time


class RuleConf:
    def __init__(self,
                 name: str,
                 enabled: bool,
                 schedule: ScheduleConf | None,
                 ticket: TicketInfo,
                 limits: RuleLimits,
                 footer_defvars: dict) -> None:

        self.name = name
        self.enabled = enabled
        self.schedule = schedule
        self.ticket = ticket
        self.limits = limits
        self.footer_defvars = footer_defvars


class DetectorConf:
    def __init__(self,
                 identity: Identity,
                 name: str,
                 store: str,
                 scene: MaskConf,
                 rules: list[RuleConf],
                 init_imbuilder: EventMeasImBuilderConf,
                 fini_imbuilder: EventMeasImBuilderConf,
                 lost_tout_usec: int,
                 dead_tout_usec: int) -> None:

        self.identity = identity
        self.name = name
        self.store = store
        self.scene = scene
        self.rules = rules
        self.init_imbuilder = init_imbuilder
        self.fini_imbuilder = fini_imbuilder
        self.log_lost_tout_usec = lost_tout_usec * 1e6
        self.log_dead_tout_usec = dead_tout_usec * 1e6
