from typing import Final, Self

from edge.services.types.about import IAboutService
from edge.services.types.tz import ITzService
from edge.support.service import ServicePack
from speedcontrol.services.types.db import IDbService
from edge.services.types.vs import IVsService


class RuleDeps:
    def __init__(self,
                 tz_service: ITzService,
                 vs_service: IVsService,
                 about_service: IAboutService):

        self.tz = tz_service
        self.vs = vs_service
        self.about = about_service


class DetectorDeps(RuleDeps):
    def __init__(self,
                 tz_service: ITzService,
                 vs_service: IVsService,
                 about_service: IAboutService,
                 db_service: IDbService):

        super().__init__(tz_service, vs_service, about_service)
        self.db: Final[IDbService] = db_service

    @classmethod
    def create(cls, services: ServicePack) -> Self:
        return cls(
            services.get(ITzService),
            services.get(IVsService),
            services.get(IAboutService),
            services.get(IDbService))
