from typing import Self

from edge.services.types.about import IAboutService
from edge.services.types.tz import ITzService
from edge.services.types.vs import IVsService
from edge.support.service import ServicePack


class DetectorDeps:
    def __init__(self, about_service: IAboutService, vs_service: IVsService, tz_service: ITzService):
        self.about = about_service
        self.vs = vs_service
        self.tz = tz_service

    @classmethod
    def create(cls, services: ServicePack) -> Self:
        return cls(
            services.get(IAboutService),
            services.get(IVsService),
            services.get(ITzService))
