from typing import Optional

from edge.support.schedule import ScheduleConf
from edge.types.identity import Identity


class ImagesArgs:
    def __init__(self, vehicle_store: str, scene_store: str):
        self.vehicle_store = vehicle_store
        self.scene_store = scene_store


class DetectorConf:
    def __init__(self,
                 name: str,
                 enabled: bool,
                 require_plate: bool,
                 schedule_args: Optional[ScheduleConf],
                 blob_store_args: ImagesArgs,
                 identity: Identity,
                 plate_detected_mode: bool = False,
                 le_loop_ref: Optional[str] = 'loop0',
                 with_video: bool = False):

        self.name = name
        self.enabled = enabled
        self.require_plate = require_plate
        self.schedule_args = schedule_args
        self.blob_store_args = blob_store_args
        self.identity = identity
        self.plate_detected_mode = plate_detected_mode
        self.le_loop_ref = le_loop_ref
        self.with_video = with_video
