from typing import Dict

from edge.services.types.tz import ITzService
from speedcontrol.events.jnode.origin import encode__origin
from speedcontrol.events.measurement import Measurement


def encode__measurement(self: Measurement, tz_service: ITzService, with_images: bool = True) -> Dict:
    jnode = {
        'uuid': self.uuid
    }

    if self.origin:
        jnode['origin'] = encode__origin(self.origin)

    waypoints_jnode: Dict[str, Dict] = dict()
    for waypoint in self.waypoints:
        waypoints_jnode[waypoint.name] = waypoint.serialize(tz_service, with_images)

    jnode['waypoints'] = waypoints_jnode

    return jnode
