from typing import Dict

from edge import eventlog
from edge.types.exceptions import JnodeError
from speedcontrol.events.ticket import TicketInfo


def decode__ticket(ticket_jnode: Dict) -> TicketInfo:
    """
    :raise JnodeError:
    """
    # deserialize #/name
    name = ticket_jnode.get('name')
    if not (type(name) in [str]) or len(name) > 128:
        eventlog.log_e_param('#/name')
        raise JnodeError

    return TicketInfo(name)
