from abc import abstractmethod

from edge.services.types.stats import IStatsService
from edge.support import bs


class IEventCounters:
    def inc_fact(self) -> None:
        raise NotImplementedError

    @property
    def fact_count(self) -> int:
        raise NotImplementedError


class IScStatsService(IStatsService):
    @property
    @abstractmethod
    def event(self) -> IEventCounters:
        pass

    @property
    @abstractmethod
    def bs(self) -> bs.IBsCounters:
        pass
