from hgext.absorb import defaultdict

from tracker.services.types.scene_emitter import SceneEmitterConf, SceneEmitterTargetConf


def decode__scene_emitter_conf(jnode: list[dict]) -> SceneEmitterConf:
    """
    :param jnode:
        main.conf#/services/scene-emitter
    """
    skiprate_to_dirs_map = defaultdict(set)
    for target_jnode in jnode:
        skip_rate = target_jnode['SkipRate']
        event_dir = target_jnode['Dir']
        skiprate_to_dirs_map[skip_rate].add(event_dir)

    targets = [SceneEmitterTargetConf(dirs, skiprate)
               for skiprate, dirs in list(skiprate_to_dirs_map.items())]

    return SceneEmitterConf(targets)
