from tracker.services.types.scene_provider import SceneProviderConf


def decode__scene_provider_conf(jnode: dict) -> SceneProviderConf:
    """
    :param jnode:
        main.conf#/FileApi/AddSceneReact
    """
    mc_dir = jnode.get('McDir', '')
    mg_dir = jnode.get('MgDir', '')
    lr_dir = jnode.get('LrDir', '')
    ra_dir = jnode.get('RaDir', '')
    tout = jnode['Tout']

    if not mc_dir and not mg_dir:
        raise ValueError('At least one of mc_dir or mg_dir should be defined')

    if not lr_dir:
        raise ValueError('The lr_dir should be defined')

    return SceneProviderConf(mc_dir, mg_dir, lr_dir, ra_dir, tout)
