from abc import abstractmethod
from typing import Final

from edge.services.types.service import IService
from edge.types.imageref import ImageRef
from tracker.types.lrra import LrRaScene


class SceneEmitterTargetConf:
    def __init__(self, event_dirs: set[str], skip_rate: int) -> None:
        self.event_dirs: Final[set[str]] = event_dirs
        self.skip_rate: Final[int] = skip_rate


class SceneEmitterConf:
    def __init__(self, targets: list[SceneEmitterTargetConf]) -> None:
        self.targets: Final[list[SceneEmitterTargetConf]] = targets


class ISceneEmitter(IService):
    @abstractmethod
    def consume_scene(self, im_ref: ImageRef, lrra_scene: LrRaScene) -> None:
        pass
