from abc import abstractmethod
from typing import Final

from edge.services.types.service import IService
from edge.types.imageref import ImageRef
from tracker.types.lr import LrScene
from tracker.types.ra import RaScene


class SceneProviderConf:
    def __init__(self, mc_dir: str, mg_dir: str, lr_dir: str, ra_dir: str, tout_msec: str) -> None:
        self.mc_dir: Final[str] = mc_dir
        self.mg_dir: Final[str] = mg_dir
        self.lr_dir: Final[str] = lr_dir
        self.ra_dir: Final[str] = ra_dir
        self.tout_msec = tout_msec


class SceneReact:
    def __init__(self, im_ref: ImageRef | None, lr_scene: LrScene | None, ra_scene: RaScene | None) -> None:
        self.im_ref: Final[ImageRef] = im_ref
        self.lr_scene: Final[LrScene] = lr_scene
        self.ra_scene: Final[RaScene] = ra_scene


class ISceneReactHandler:
    @abstractmethod
    def handle_scene_react(self, react: SceneReact) -> None:
        pass


class ISceneReactProvider(IService):
    pass
